# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetCatalogNodesResult',
    'AwaitableGetCatalogNodesResult',
    'get_catalog_nodes',
    'get_catalog_nodes_output',
]

warnings.warn("""getCatalogNodes has been deprecated in favor of getNodes""", DeprecationWarning)

@pulumi.output_type
class GetCatalogNodesResult:
    """
    A collection of values returned by getCatalogNodes.
    """
    def __init__(__self__, datacenter=None, id=None, node_ids=None, node_names=None, nodes=None, query_options=None):
        if datacenter and not isinstance(datacenter, str):
            raise TypeError("Expected argument 'datacenter' to be a str")
        pulumi.set(__self__, "datacenter", datacenter)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if node_ids and not isinstance(node_ids, list):
            raise TypeError("Expected argument 'node_ids' to be a list")
        pulumi.set(__self__, "node_ids", node_ids)
        if node_names and not isinstance(node_names, list):
            raise TypeError("Expected argument 'node_names' to be a list")
        pulumi.set(__self__, "node_names", node_names)
        if nodes and not isinstance(nodes, list):
            raise TypeError("Expected argument 'nodes' to be a list")
        pulumi.set(__self__, "nodes", nodes)
        if query_options and not isinstance(query_options, list):
            raise TypeError("Expected argument 'query_options' to be a list")
        pulumi.set(__self__, "query_options", query_options)

    @property
    @pulumi.getter
    def datacenter(self) -> str:
        """
        The datacenter the keys are being read from to.
        """
        return pulumi.get(self, "datacenter")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="nodeIds")
    def node_ids(self) -> Sequence[str]:
        """
        A list of the Consul node IDs.
        """
        return pulumi.get(self, "node_ids")

    @property
    @pulumi.getter(name="nodeNames")
    def node_names(self) -> Sequence[str]:
        """
        A list of the Consul node names.
        """
        return pulumi.get(self, "node_names")

    @property
    @pulumi.getter
    def nodes(self) -> Sequence['outputs.GetCatalogNodesNodeResult']:
        """
        A list of nodes and details about each Consul agent.  The list of
        per-node attributes is detailed below.
        """
        return pulumi.get(self, "nodes")

    @property
    @pulumi.getter(name="queryOptions")
    def query_options(self) -> Optional[Sequence['outputs.GetCatalogNodesQueryOptionResult']]:
        return pulumi.get(self, "query_options")


class AwaitableGetCatalogNodesResult(GetCatalogNodesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCatalogNodesResult(
            datacenter=self.datacenter,
            id=self.id,
            node_ids=self.node_ids,
            node_names=self.node_names,
            nodes=self.nodes,
            query_options=self.query_options)


def get_catalog_nodes(query_options: Optional[Sequence[pulumi.InputType['GetCatalogNodesQueryOptionArgs']]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCatalogNodesResult:
    """
    The `get_nodes` data source returns a list of Consul nodes that have
    been registered with the Consul cluster in a given datacenter.  By specifying a
    different datacenter in the `query_options` it is possible to retrieve a list of
    nodes from a different WAN-attached Consul datacenter.


    :param Sequence[pulumi.InputType['GetCatalogNodesQueryOptionArgs']] query_options: See below.
    """
    pulumi.log.warn("""get_catalog_nodes is deprecated: getCatalogNodes has been deprecated in favor of getNodes""")
    __args__ = dict()
    __args__['queryOptions'] = query_options
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('consul:index/getCatalogNodes:getCatalogNodes', __args__, opts=opts, typ=GetCatalogNodesResult).value

    return AwaitableGetCatalogNodesResult(
        datacenter=pulumi.get(__ret__, 'datacenter'),
        id=pulumi.get(__ret__, 'id'),
        node_ids=pulumi.get(__ret__, 'node_ids'),
        node_names=pulumi.get(__ret__, 'node_names'),
        nodes=pulumi.get(__ret__, 'nodes'),
        query_options=pulumi.get(__ret__, 'query_options'))


@_utilities.lift_output_func(get_catalog_nodes)
def get_catalog_nodes_output(query_options: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetCatalogNodesQueryOptionArgs']]]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetCatalogNodesResult]:
    """
    The `get_nodes` data source returns a list of Consul nodes that have
    been registered with the Consul cluster in a given datacenter.  By specifying a
    different datacenter in the `query_options` it is possible to retrieve a list of
    nodes from a different WAN-attached Consul datacenter.


    :param Sequence[pulumi.InputType['GetCatalogNodesQueryOptionArgs']] query_options: See below.
    """
    pulumi.log.warn("""get_catalog_nodes is deprecated: getCatalogNodes has been deprecated in favor of getNodes""")
    ...
